Leetcode198-House Robber

  1. House Robber

Easy

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Example 1:

Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
             Total amount you can rob = 1 + 3 = 4.

Example 2:

Input: [2,7,9,3,1]
Output: 12
Explanation: Rob house 1 (money = 2), rob house 3 (money = 9) and rob house 5 (money = 1).
             Total amount you can rob = 2 + 9 + 1 = 12.

思路1

每个房子有偷和不偷两种选择,最优子结构容易看出:
对于最后一个房子,假如我们要偷,那么前一个就不能偷。
F(4) = MAX(F(3),F(2) + nums[4])
再确定边界即可。主要就是把大问题转化成小问题。

解法1

class Solution {
    public int rob(int[] nums) {
        return robHouse(nums, nums.length - 1);
    }
    
    public int robHouse(int[] nums, int n) {
        if(n < 0) {
            return 0;
        }	
        return Math.max(robHouse(nums, n - 1), robHouse(nums, n - 2) + nums[n]);
    }
}

思路2

在思路1的基础上,我们发现有大量重复计算,时间复杂度过高。所以可以优化一下。利用空间换时间的思想,将计算结果存起来,以便后面利用。

解法2

class Solution {
    public int rob(int[] nums) {
        if(nums == null || nums.length == 0) {
            return 0;
        }      
        int[] dp = new int[nums.length];
        dp[0] = nums[0];
        if(nums.length >= 2) {
            dp[1] = Math.max(nums[0], nums[1]);
        }
        for(int i = 2; i < nums.length; i++) {
            dp[i] = Math.max(dp[i-1],dp[i-2] + nums[i]);
        }
        return dp[nums.length - 1];
    }
}

思路3

由于F(n)= MAX(F(n-1),F(n-2)+ nums[n]),也就是说:F(n)的结果依赖之前计算结果的只有F(n-1)和F(n-2)。所以可以用两个整型变量代替dp数组。空间复杂度降至O(1)。

解法3

class Solution {
    public int rob(int[] nums) {
        if(nums == null || nums.length == 0) {
            return 0;
        }      
        if(nums.length == 1) {
            return nums[0];
        }       
        int prePre = nums[0], pre = Math.max(nums[0], nums[1]), temp = 0;
        for(int i = 2; i < nums.length; i++) {
            temp = Math.max(pre,prePre + nums[i]);
            prePre = pre;
            pre = temp;
        }       
        return pre;
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值